#!/usr/bin/env python
# -*- coding: iso-8859-15 -*-

import pygtk
pygtk.require('2.0')
import gtk

gtk.gdk.threads_init()

import recPage
import playPage
import playrecthread

import alsaaudio
#import ogg
import config

class DiktatorGtk:

    def destroy(self, widget, data=None):
        print "Enough dictation for now! \nWhat about democracy further on?"
        gtk.main_quit()
        if (not self.pr_thread is None):
            self.pr_thread.kill()
        
    def __init__(self):
        
        #TODO: change state or change all mixers 
        self.configure_ALSA_state()
        
        #load config
        self.conf = config.DictatorConfig()
        #start playrecthread
        
        try:
            self.pr_thread = playrecthread.PlayRecThread(self.conf)
            self.pr_thread.start()
        except:
            print "ALSA was unable to open slave. Please restart!"
            self.pr_thread = None
            
        # create a new window
        #gtk.gdk.threads_init()
        self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
        self.window.resize(480,640)
        self.window.set_title("Diktator")
        self.window.connect("destroy", self.destroy)
        
        #Notebook - Tabs
        self.vbox = gtk.VBox()
        self.tabs = gtk.Notebook()
        self.tabs.set_property("homogeneous",True)
        self.tabs.set_property("tab-vborder",15)
        
        #Bilder
        self.rec_tab_img = gtk.image_new_from_stock(gtk.STOCK_MEDIA_RECORD, gtk.ICON_SIZE_BUTTON)
        self.rec_tab_img.set_property("icon-size",6)
        self.play_tab_img = gtk.image_new_from_stock(gtk.STOCK_MEDIA_PLAY, gtk.ICON_SIZE_BUTTON)   
        self.play_tab_img.set_property("icon-size",6)  
        
        #recPage
        self.recp = recPage.RecPage(self.pr_thread,self.conf)
        self.tabs.append_page(self.recp.mainBox,self.rec_tab_img)
        self.tabs.child_set(self.recp.mainBox,"tab-expand",True)
        
        #playPage
        self.playp = playPage.PlayPage(self.pr_thread,self.conf)
        img = gtk.image_new_from_stock(gtk.STOCK_MEDIA_PLAY, gtk.ICON_SIZE_BUTTON)   
        img.set_property("icon-size",6)  
        self.tabs.append_page(self.playp.mainBox,self.play_tab_img) 
        self.tabs.child_set(self.playp.mainBox,"tab-expand",True)
        self.tabs.connect("switch-page",self.reload_playp)    
        box = gtk.HBox()
        self.vbox.add(self.tabs)
        
        #Pack Notebook into Window
        self.window.add(self.vbox)
        self.window.show_all()
        
    def configure_ALSA_state(self):
        #print "nothing configured" 
        pass      
    def reload_playp(self,notebook=None,page=None,page_num=None):
        if page_num == 1:
            self.playp.update_list()
            
    def main(self):
        gtk.gdk.threads_enter()
        gtk.main()
        gtk.gdk.threads_leave()
        
if __name__ == "__main__":
    main_GUI = DiktatorGtk()
    main_GUI.main()