#!/usr/bin/env python
# -*- coding: iso-8859-15 -*-
import pygtk
pygtk.require('2.0')
import gtk,gobject
import os,re,threading,datetime
import config
import alsaaudio, wave
from time import sleep

class PlayPage:
    def __init__(self,pr_thread,conf):
#TODO: jedesmal, wenn diese Seite geffnet wird, liest sie
# die Dateien neu ein!!!        
        #initialize config
        self.conf = conf
        
        self.playthread=pr_thread
        
        self.files,self.folder=self.getFolderContent()
########################
#      Dateiliste      #
########################
        
        self.list = gtk.ListStore(str,str,str)
        for i in range(len(self.files)):
            #print self.files[i][1]
            iter = self.list.append([self.files[i][0],self.files[i][1],self.files[i][2]])
            
        self.tree = gtk.TreeView(self.list)
        
        column1 = gtk.TreeViewColumn("filename")
        column2 = gtk.TreeViewColumn("timestamp")
        column3 = gtk.TreeViewColumn("length")
        self.tree.append_column(column1)
        self.tree.append_column(column2)
        self.tree.append_column(column3)
        cell = gtk.CellRendererText()
        column1.set_resizable(True)
        column1.pack_start(cell,False)
        column1.add_attribute(cell,'text',0)
        column1.set_sort_column_id(0)
        column2.set_resizable(True)
        column2.pack_start(cell,False)
        column2.add_attribute(cell,'text',1)
        column2.set_sort_column_id(1)
        column3.set_resizable(True)
        column3.pack_start(cell,False)
        column3.add_attribute(cell,'text',2)
        column3.set_sort_column_id(2)
       
        
# timelabel
        self.timelabel = gtk.Label()
        self.timelabel.set_use_markup(True)
        self.timelabel.set_property("height-request",50)
# event-box for changing timelabel-bg etc.
        self.eb = gtk.EventBox()
        self.old_col =  self.eb.get_style().bg[gtk.STATE_NORMAL]
        self.eb.add(self.timelabel)


# button-images
        self.playImg = img = gtk.image_new_from_stock(gtk.STOCK_MEDIA_PLAY, gtk.ICON_SIZE_BUTTON)
        self.pauseImg = img = gtk.image_new_from_stock(gtk.STOCK_MEDIA_PAUSE, gtk.ICON_SIZE_BUTTON)
        stopImg = img = gtk.image_new_from_stock(gtk.STOCK_MEDIA_STOP, gtk.ICON_SIZE_BUTTON)
        rewImg = img = gtk.image_new_from_stock(gtk.STOCK_MEDIA_REWIND, gtk.ICON_SIZE_BUTTON)
        fwImg = img = gtk.image_new_from_stock(gtk.STOCK_MEDIA_FORWARD, gtk.ICON_SIZE_BUTTON)
        
###################
#     Buttons     #
###################              
        self.playBut = gtk.Button()
        self.playBut.set_image(self.playImg)
        self.playBut.set_property("height-request",100)
        if (not self.playthread is None):
            self.connectID = self.playBut.connect("clicked",self.play_file)
        
        self.stopBut = gtk.Button()
        self.stopBut.set_image(stopImg)
        if (not self.playthread is None):
            self.stopBut.connect("clicked",self.stop_playing)
        
        self.rewBut = gtk.Button()
        self.rewBut.set_image(rewImg)
        if (not self.playthread is None):
            self.rewID = self.rewBut.connect("clicked",self.rewind)
            
        self.fwBut = gtk.Button()
        self.fwBut.set_image(fwImg)
        if (not self.playthread is None):
            self.fwID = self.fwBut.connect("clicked",self.forward)
            
#################
#    packing    #
#################    
        hbutton_box = gtk.HButtonBox()
        hbutton_box.set_layout(gtk.BUTTONBOX_SPREAD)
        
        hbutton_box.add(self.rewBut)
        hbutton_box.add(self.stopBut)
        hbutton_box.add(self.playBut)
        hbutton_box.add(self.fwBut)
        
        self.sw = gtk.ScrolledWindow()
        self.sw.set_size_request(450,300)
        self.sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_ALWAYS)
        self.sw.add(self.tree)
        
        self.mainBox = gtk.VBox()
        self.mainBox.pack_start(self.sw,True,True,10)
        self.mainBox.pack_start(self.eb,False,False,10)
        self.mainBox.pack_start(hbutton_box,False,False,10)
        
    def getMbox(self):
        return self.mainBox
    
    def getFolderContent(self):
        #configdatei auslesen
        folder = self.conf.get_folder()
        
        # TODO: Lnge der Dateien wre schn!
        checker = re.compile(r".*.(ogg|mp3|wav)")
        files=[]
        
        ausgabe=os.popen(" ls -F " + folder + " | grep -v /$")   
        dateien = [zeile.strip() for zeile in ausgabe]
        
        filetypes = ['@','*','=']
        for fileprops in dateien:
            #get the filename
            if fileprops[len(fileprops)-1:] in filetypes:
                filename = fileprops[:len(fileprops)-1]
            else:
                filename = fileprops
            #get the according timestamp
            timestamp = datetime.datetime.fromtimestamp(os.path.getmtime(folder +"/"+ filename)).isoformat().replace("T"," ")
            
            #get the length
            if filename[len(filename)-3:] == 'wav':
                length = self.get_wave_length(folder + "/" + filename)
            elif filename[len(filename)-3:] == 'ogg':
                length = self.get_ogg_length(folder + "/" + filename)
            else:
                length = ' '    
                
            if (checker.match(filename)!=None):
                files.append([filename,timestamp,length])
        files.sort()        
        return files,folder
    
    def play_file(self, widget):
        try:
            selection = self.tree.get_selection()
            filename = self.list.get_value(selection.get_selected()[1], 0)
        except:
            self.timelabel.set_markup('<span size="12000">No file was selected!</span>')
            print "No file was selected!"
        else:
            
            path = self.conf.get_folder()
            ffname = path.strip() + "/" + filename.strip() 
                
            self.playthread.play(ffname,self,self.list.get_value(selection.get_selected()[1], 2))
            self.switch_back_playBut(self.pause_playing,self.pauseImg)
            self.eb.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("#FF3333"))
            
    def stop_playing(self,widget):
        self.playthread.stop()
        self.switch_back_playBut(self.play_file,self.playImg)
        self.eb.modify_bg(gtk.STATE_NORMAL,self.old_col)
    
    def pause_playing(self,widget):
        self.playthread.pause()
        self.switch_back_playBut(self.resume_playing,self.playImg)
        
    def resume_playing(self,widget):
        self.playthread.play()
        self.switch_back_playBut(self.pause_playing,self.pauseImg)
        self.eb.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("#FF3333"))
        
    def forward(self,widget):
        self.playthread.forward()
        self.switch_back_playBut(self.normal_playing,self.playImg)        
        
    def rewind(self,widget):
        self.playthread.rewind()
        self.switch_back_playBut(self.normal_playing,self.playImg)
        
    def normal_playing(self,widget):
        self.playthread.normal()
        self.switch_back_playBut(self.pause_playing,self.pauseImg)
        
        self.fwBut.disconnect(self.fwID)
        self.fwID = self.fwBut.connect("clicked",self.forward)
        
        self.rewBut.disconnect(self.rewID)
        self.rewID = self.rewBut.connect("clicked",self.rewind)
        
    def switch_back_playBut(self,function,pic=None):
        self.playBut.disconnect(self.connectID)
        self.connectID = self.playBut.connect("clicked",function)
        if pic != None:
            self.playBut.set_image(pic)
            
    def get_wave_length(self,filename):

        wfile = wave.open(filename, "r")
        length = (1.0 * wfile.getnframes()) / wfile.getframerate()
        wfile.close()
        length = round(length)
        
        if length > 60.0:
            mins = int(length/60)
            secs = int(length%60)
            if mins < 10:
                mins = '0' + str(mins)
            if secs < 10:
                secs = '0' + str(secs-1)
            time = str(mins) + ":" + str(secs)
        else:
            
            time = "00:" + ('0' + str(int(length)) if length < 10 else str(int(length)))
        return time
    
    def get_ogg_length(self,filename):
        length = 'x:xx '
        return length
            
    def update_list(self):
        self.files,self.folder=self.getFolderContent()
        self.list.clear()
        for i in range(len(self.files)):
            #print self.files[i][1]
            iter = self.list.append([self.files[i][0],self.files[i][1],self.files[i][2]])
        #self.tree.set_model(self.list)
        pass   